// Gray - A simple ray tracing program
// Copyright (C) 2008-2018 Eric Bechet
//
// See the COPYING file for contributions and license information.
// Please report all bugs and problems to <bechet@cadxfem.org>.
//

#ifndef __GLU_GRAY_H_
#define __GLU_GRAY_H_
#include <vector>
#ifdef WIN32
#include "windows.h"
#endif //WIN32
#include <GL/gl.h>
#include "ray.h"
#include "ndata.h"


struct Tri
{
  unsigned int p[3];
  Tri ( unsigned int a,unsigned int b,unsigned int c )
  {
    p[0]=a;
    p[1]=b;
    p[2]=c;
  }
};

struct Quad
{
  unsigned int p[4];
  Quad ( unsigned int a, unsigned int b, unsigned int c, unsigned int d )
  {
    p[0] = a;
    p[1] = b;
    p[2] = c;
    p[3] = d;
  }
};

class glmeshbuffer
{
  std::vector<Point> vertices;
  std::vector<Point> normals;
  std::vector<Tri> triangles;
  std::vector<Quad> quads;
public:
  glmeshbuffer ( int nv,int nt, int nq = 0 );
  int add_vertex ( Point v,Point n );
  int add_triangle ( int a,int b,int c );
  int add_quad ( int a, int b, int c, int d );
  void draw ( void );
};


#endif // __GLU_GRAY_H_

// kate: indent-mode cstyle; indent-width 2; replace-tabs on; 
