// nUtil - An utility Library for gnurbs
// Copyright (C) 2008-2018 Eric Bechet
//
// See the LICENSE file for contributions and license information.
// Please report all bugs and problems to <bechet@cadxfem.org>.
//

#ifndef __NDISPLAY_H
#define __NDISPLAY_H

#include "nutilconfig.h"
#include "nutil.h"

#ifdef INTERFACE_TYPE_VTK
#include "vtkdisplay.h"
typedef vtkdisplay ndisplay ;
#endif

#ifdef INTERFACE_TYPE_FLTK
#include "fltkdisplay.h"
typedef fltkdisplay ndisplay ;
#endif

#ifndef INTERFACE_TYPE_VTK 
#ifndef INTERFACE_TYPE_FLTK
// dummy class that does nothing but allows compilation without graphical output.
// useful for portable code mainly used without GUI
class ndisplay : public ndisplay_base
{
public: 
  virtual ~ndisplay() {}
  virtual void init_data(const data_container &data) {};   // all
  virtual void init_data(const std::vector<data_container> &data) {};   // all
  virtual void display(bool perspectiveon=0) {};   // display loop
};
#endif
#endif

#endif// __NDISPLAY_H
